import React, {Component} from "react";
import '../Style.css'
import {Link} from "react-router-dom";

class Eleves extends Component {
    constructor(props) {
        super(props);
        this.state = {
            // Liste des élèves inscrits au semestre
            students: [],
        };
    }

    componentWillMount() {
        let dept = window.location.href.split('/')[6]
        let sem = window.location.href.split('/')[8]
        let BASE_URL = window.$api_url
        fetch(BASE_URL + dept +
            '/Scolarite/Notes/groups_view?with_codes=1&format=json&formsemestre_id=' + sem, {
            method: 'GET',
            verify: false,
            credentials: 'include',
        })
            .then(response =>
                // Traitement des données JSON
                response.json().then(data => ({
                        data: data,
                    })
                ).then(res => {
                    // Gestion des données sous forme de tableau a deux colonnes
                    const dat = res.data.map((x,i) => {
                        return i % 2 === 0 ? res.data.slice(i, i+2) : null;
                    }).filter(x => x != null);
                    this.setState({ students: dat});
                }));
    }

    render() {
        return (
            <div className="wrapper">
                <h1 id="pageTitle">Liste des élèves</h1>
                <div className="container">
                    {this.state.students.map((students, index) => {
                        // Creation du tableau de deux colonnes
                        return (
                            <div className="row justify-content-center">
                                {students.map((etud, index) => {
                                    return (
                                        <div className="col" key={index} id="wrapDept">
                                            <Link to={`/ScoDoc/static/mobile/${window.location.href.split('/')[6]}/Scolarite/Etudiant/${etud.etudid}`}>
                                                {/* Recuperation de la photo de l'etudiant */}
                                                <img
                                                    alt={`${etud.nom_disp} ${etud.prenom}`}
                                                    src={`/ScoDoc/RT/Scolarite/Notes/get_photo_image?etudid=${etud.etudid}`}
                                                    width="102"
                                                    height="128"
                                                    className="d-inline-block align-top"
                                                />{' '}<br/>
                                                {etud.nom_disp} {etud.prenom}
                                            </Link>
                                        </div>
                                    )
                                })}
                            </div>
                        )
                    })}
                </div>
            </div>
        )
    }
}

export default Eleves